﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Diagnostics;

using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Binary;

using Microsoft.Xna.Framework;

using Equis.JanusToolkit;
using Equis.JanusToolkit.StandardTimeLines;

namespace Equis.Tanks 
{
    [Serializable]
    public class TankCommand
    {
        public int RemoteLag;
        public int Duration;
        public float VelocityX;
        public float VelocityY;
        public float VelocityRot;
        public bool Shooting;
        public bool Fire;
        public int Time;

        public TankCommand(int _remoteLag, int _duration, float _velocityX, float _velocityY, float _velocityRot, bool _shooting, bool _fire, int _time)
        {
            RemoteLag = _remoteLag;
            Duration = _duration;
            VelocityX = _velocityX;
            VelocityY = _velocityY;
            VelocityRot = _velocityRot;
            Shooting = _shooting;
            Fire = _fire;
            Time = _time;
        }

        public TankCommand()
        {
        }
    }  
    
    /// <summary>
    /// Stream for sprite position, heading and velocity
    /// Values are stored in a TankCommand 
    /// X = x position
    /// Y = y position
    /// HeadingX = X heading
    /// HeadingY = Y heading
    /// VelocityX = X velocity
    /// VelocityY = Y velocity
    /// Shooting = status if shooting or not
    /// </summary>
    public class TankCommandTimeLine : CommandTimeLine<TankCommand>
    {

        public TankCommandTimeLine(String name)
            : base(name)
        {
        }
    }
}