﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Equis.JanusToolkit
{

    /// <summary>
    /// Simple logger for writing messages to a text file
    /// </summary>
    public class JanusLogger
    {

        private static JanusLogger _logger = null;
        private StreamWriter _logfile;


        private static string LogFileName = "logfile";
        private static string LogFileExtention = "txt";
        private static int LogFileInstance = 0;

        /// <summary>
        /// Create a logger is this is the first time called
        /// </summary>
        public static JanusLogger Instance
        {
            get
            {
                if (_logger == null)
                {
                    _logger = new JanusLogger();
                }
                return _logger;
            }
        }


        /// <summary>
        /// Write a message to the log file
        /// </summary>
        public void log(string message)
        {
            _logfile.WriteLine(message);
            _logfile.Flush();
        }

        private JanusLogger()
        {
            bool success = false;
            while (!success)
            {
                try
                {
                    FileInfo f = new FileInfo(LogFileName + LogFileInstance + "." + LogFileExtention);
                    _logfile = f.CreateText();
                    success = true;

                }
                catch
                {
                    LogFileInstance++;
                }
            }
        }
    }
}
