﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using Equis.JanusToolkit;

namespace Equis.JanusToolkit.StandardTimeLines
{


    /// <summary>
    /// ComamndTimeLine for string commands
    /// </summary>
    public class StringCommandTimeLine : CommandTimeLine<string>
    {
        /// <summary>
        /// Create a new instance of a StringCommandTimeLine object
        /// and subscribe to updates for that time line
        /// </summary>
        /// <param name="name">CommandTimeLine name</param>
        public StringCommandTimeLine(String name)
            : base(name)
        {
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="byteArray"></param>
        /// <returns></returns>
        protected override string ByteArrayToValue(byte[] byteArray)
        {
            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < byteArray.Length; i++)
            {
                sb.Append((char)byteArray[i]);
            }

            return sb.ToString();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="v"></param>
        /// <returns></returns>
        protected override byte[] ValueToByteArray(string v)
        {
            byte[] byteArray = new byte[v.Length];

            for (int i = 0; i < v.Length; i++)
            {
                byteArray[i] = (byte)v[i];
            }

            return byteArray;
        }
    }
}