﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Equis.Logging
{
    public class ResultLogger
    {
        public enum Level { CriticalError, Error, Debug };

        private static ResultLogger _logger = null;
        private StreamWriter _logfile;

        public static Level LogLevel = Level.Debug;

        public static string LogFileName = "ResultWarpLog";
        public static string LogFileExtention = "csv";
        public static int LogFileInstance = 0;
        public static ResultLogger Instance
        {
            get
            {
                if (_logger == null)
                {
                    _logger = new ResultLogger();
                }
                return _logger;
            }
        }

        public void log(Level messageLevel, string message)
        {
            if (messageLevel <= LogLevel)
            {
                _logfile.WriteLine(message);
                _logfile.Flush();  // make sure buffer flushed in case of crash
            }
        }

        public void log(string message)
        {
            log(Level.Debug, message);
        }

        private ResultLogger()
        {
            bool success = false;
            while (!success)
            {
                try
                {
                    FileInfo f = new FileInfo(LogFileName + LogFileInstance + "." + LogFileExtention);
                    _logfile = f.CreateText();
                    success = true;

                }
                catch
                {
                    LogFileInstance++;
                }
            }
        }
    }
}
