﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Equis.JanusToolkit
{
    public partial class ServerForm : Form
    {
        TextBoxStreamWriter _messageWriter;

        public ServerForm()
        {
            InitializeComponent();
        }

        public void FlushMessages()
        {
            _messageWriter.Flush();
        }

        public void AddClient(int id)
        {
            clientGrid.Rows.Add(new object[] { id.ToString() });
            clientGroup.Text = "Clients (" + clientGrid.Rows.Count + ")";
        }

        public void RemoveClient(int id)
        {
            foreach (DataGridViewRow row in clientGrid.Rows)
            {
                if (row.Cells[0].Value.ToString() == id.ToString())
                {
                    clientGrid.Rows.Remove(row);

                    if (clientGrid.Rows.Count > 0) clientGroup.Text = "Clients (" + clientGrid.Rows.Count + ")";
                    else clientGroup.Text = "Clients";

                    break;
                }
            }
        }

        public void SetClientRTT(int id, int rtt)
        {
            foreach (DataGridViewRow row in clientGrid.Rows)
            {
                if (row.Cells[0].Value.ToString() == id.ToString())
                {
                    row.Cells[1].Value = rtt.ToString() + " ms";
                    break;
                }
            }
        }

        public void AddTimeLine(int id, string name)
        {
            timeLineGrid.Rows.Add(new object[] { id.ToString(), name });
            timeLineGroup.Text = "TimeLines (" + timeLineGrid.Rows.Count + ")";
        }

        public void RemoveTimeLine(int id)
        {
            foreach (DataGridViewRow row in timeLineGrid.Rows)
            {
                if (row.Cells[0].Value.ToString() == id.ToString())
                {
                    timeLineGrid.Rows.Remove(row);

                    if (timeLineGrid.Rows.Count > 0) timeLineGroup.Text = "TimeLines (" + timeLineGrid.Rows.Count + ")";
                    else timeLineGroup.Text = "TimeLines";

                    break;
                }
            }
        }

        private void ServerForm_Load(object sender, EventArgs e)
        {
            _messageWriter = new TextBoxStreamWriter(messageText);
            Console.SetOut(_messageWriter);
        }
    }
}
