﻿using System;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace Equis.JanusToolkit
{
    public class TextBoxStreamWriter : TextWriter
    {
        TextBox _output;
        StringBuilder _buffer;

        public TextBoxStreamWriter(TextBox output)
        {
            _output = output;
            _buffer = new StringBuilder();
        }

        public override void Write(char value)
        {
            base.Write(value);
            _buffer.Append(value);
        }

        public override void Flush()
        {
            lock (_buffer)
            {
                if (_buffer.Length != 0)
                {
                    _output.AppendText(_buffer.ToString());
                    _buffer.Clear();
                }
            }

            base.Flush();
        }

        public override Encoding Encoding
        {
            get { return System.Text.Encoding.UTF8; }
        }
    }
}
