﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Diagnostics;

using Lidgren.Network;


namespace Equis.JanusToolkit
{
    class TimeLineMsg
    {
        public Int64 time;
        public UInt16 length;
        public byte[] message;

        public TimeLineMsg(Int64 _time, UInt16 _length, byte[] _message)
        {
           time = _time;
           length = _length;
           message = _message;            
        }


    }
    ///
    /// For each timeline, records the client connections subscribing to that timeline
    ///
    class TimeLineMsgBuffer
    {
        private List<TimeLineMsg> TimeLineMessages;
        private Int32 _MaxMessages;

        public void AddMessage(Int64 _time, UInt16 _length, byte[] _message)
        {
            if (_MaxMessages > 0) 
            {
                if (TimeLineMessages.Count == _MaxMessages)
                {
                    TimeLineMessages.RemoveAt(0);
                }
                TimeLineMessages.Add(new TimeLineMsg(_time, _length, _message));
            }

        }

        public Int32 MaxMessages
        {
            set { _MaxMessages = value; }
        }


        public List<TimeLineMsg> GetMessages()
        {
            return TimeLineMessages;
        }


        public TimeLineMsgBuffer(Int32 maxMessages)
        {
            TimeLineMessages = new List<TimeLineMsg>();
            _MaxMessages = maxMessages;
        }
    }
}
